// Sale.h : Declaration of the CSale

#ifndef __SALE_H_
#define __SALE_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CSale
class ATL_NO_VTABLE CSale : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CSale, &CLSID_Sale>,
	public IDispatchImpl<ISale, &IID_ISale, &LIBID_SHOPCOMLib>
{
public:
	CSale()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SALE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSale)
	COM_INTERFACE_ENTRY(ISale)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ISale
public:
	STDMETHOD(AddSale)(/*[in]*/ BSTR strUser, /*[in]*/ BSTR strPass, /*[in]*/ LONG lCustomerID, /*[in]*/ DOUBLE dDate, /*[in]*/ _Recordset * rsDetails, /*[out, retval]*/ LONG * lStatus);
	STDMETHOD(CreateSalesDetail)(/*[in]*/ BSTR strUser, /*[in]*/ BSTR strPass, /*[out, retval]*/ _Recordset ** rsDetails);
};

#endif //__SALE_H_
