// User.h : Declaration of the CUser

#ifndef __USER_H_
#define __USER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CUser
class ATL_NO_VTABLE CUser : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CUser, &CLSID_User>,
	public IDispatchImpl<IUser, &IID_IUser, &LIBID_SHOPCOMLib>
{
public:
	CUser()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_USER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CUser)
	COM_INTERFACE_ENTRY(IUser)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IUser
public:
	
	STDMETHOD(Validate)(/*[in]*/ BSTR strUser, /*[in]*/ BSTR strPass, /*[out, retval]*/ LONG * lStatus);

};

#endif //__USER_H_
