#include "stdafx.h"

/////////////////////////////////////////////////////////////////////////////

//
// definiao da string de conexo
//
_bstr_t strConn = _T("Provider=Microsoft.Jet.OLEDB.4.0;Data Source="PATH_BD";User ID=;Password=;");


/////////////////////////////////////////////////////////////////////////////

LONG ValidateUser(BSTR strUser, BSTR strPass)
{
	LONG lStatus = SHOP_STATUS_NOT_OK;
	
	_bstr_t _strUser(strUser);
	_bstr_t _strPass(strPass);
	_bstr_t strCmd;

	_ConnectionPtr spConn = NULL;
	_RecordsetPtr  spRs   = NULL;

	try
	{
		//
		// criar conexo
		//
		TESTAHR( spConn.CreateInstance(__uuidof(Connection)) );

		//
		// criar um recordset para o resultado
		//
		TESTAHR( spRs.CreateInstance(__uuidof(Recordset)) );

		//
		// abrir conexo
		//
		spConn->Open(strConn, "", "", adConnectUnspecified);

		//
		// configurar recodset, cursor do lado do cliente
		//
		spRs->PutCursorLocation(adUseClient);

		//
		// Associar a conexo ao recordset
		//
		spRs->PutRefActiveConnection(spConn); 

		//
		// construir o comando SQL a executar
		//
		strCmd = _bstr_t("SELECT * FROM users WHERE user='")+_strUser+"' and pass='"+_strPass+"'";

		//
		// executar o comando e preencher o recordset
		//
		spRs->Open(strCmd, strConn, adOpenStatic, adLockReadOnly, -1L); 

		//
		// verificar o resultado
		//
		if ( spRs->GetRecordCount() == 0L ) // no existe utilizador ou password invlida
			
			lStatus = SHOP_STATUS_INVALID_LOGIN;
		
		else								// login vlido
		
			lStatus = SHOP_STATUS_OK;
	}
	catch(_com_error &e)
	{
		::MessageBox(NULL, e.Description(), "Erro COM", MB_OK);

		lStatus = SHOP_STATUS_COM_ERROR;
	}

	return lStatus;
}

/////////////////////////////////////////////////////////////////////////////


_Recordset* GetByID(char * strTable, char * strField, LONG lKey, BOOL bStaticRS /* = FALSE */)
{
	//
	// inicializar recordset de retorno
	//
	_Recordset*		rsRet = NULL;
	_RecordsetPtr	spRs  = NULL;
	_bstr_t strCmd;

	try{
		//
		// criar um recordset para o resultado
		//
		TESTAHR( spRs.CreateInstance(__uuidof(Recordset)) );

		//
		// definir comando SQL a executar
		//
		strCmd=_bstr_t("SELECT * FROM ") + strTable + _bstr_t(" WHERE ") + strField + _bstr_t("=") + _bstr_t(lKey);

		//
		// configurar recodset, cursor do lado do cliente
		//
		spRs->PutCursorLocation(adUseClient);

		//
		// executar o comando e preencher o recordset usando uma conexo "escondida"
		//
		spRs->Open(strCmd, strConn, (bStaticRS ? adOpenStatic : adOpenKeyset), adLockOptimistic, -1L); 

		//
		// configurar recordset, desligar a conexo do recordset
		//
		spRs->PutRefActiveConnection(NULL);

		//
		// adicionar uma referncia pois vamos enviar o recordset para o exterior
		//
		spRs->AddRef();

		//
		// guardar o recordset para retornar no parametro de output
		//
		rsRet = spRs;
	}
	catch(_com_error &e)
	{
		::MessageBox(NULL, e.Description(), "Erro", MB_OK);
	}

	//
	// retornar o recordset
	//
	return rsRet;
}

/////////////////////////////////////////////////////////////////////////////
